/* Support for SeaTalk1 input 
   ==========================
*/

//char ST[18];          // buffer to store the SeaTalk datagram defined in main INO file
uint8_t i_ST;           // index for the ST[] buffer
uint8_t last_ST;        // last index of datagram lenght - 1

// this is only to record ST datagrams on nmea4
int len_ST = 0;

void TestSeaTalk() {
  len_ST = 0;  
  uint16_t inbyte;   // also used to set i_4
  while (Serial_ST_available() > 0) {    // get the character
    inbyte = Serial_ST_read();
    if ( Is_ST ) {
      if ( highByte(inbyte) ) {
        // changed from 31 to 32
        if ( Skip_4 < FltSkip_4 ) {
          Skip_4 = Skip_4 + 1;
          Is_ST = false; return; }
        else {
          Skip_4 = 0;      
          ST[0] = lowByte(inbyte); 
          last_ST = GetLast_ST(ST[0]);
          if ( last_ST ) { 
            i_ST = 1; 
          }
          else {
            Is_ST = false; return; 
          }
        }
      }
      ST[i_ST] = lowByte(inbyte); 
      // added from 31 to 32
      if ( i_ST == 1 ) {
        uint8_t jj = (ST[1] & 0x0F) + 2;
        if ( jj != last_ST ){
          Is_ST = false; return;  
        }
      }  
      if ( i_ST == last_ST ) {   
        inbyte = Parse_ST( ST[0] );
        if ( inbyte ) {
          if ( Led4 == false ) { Led4 = true; }
          i_4 = inbyte;
          // error in version 26 missing CR LF in nmea_4
          nmea_4[i_4 - 1] = 0x0D;
          nmea_4[i_4] = 0x0A;
          nmea_4[i_4 + 1] = 0x00;  
          if ( CSum_4 ) {
            if ( Is_CKS_Wrong(nmea_4) ){ Is_ST = false; return; }
          }  
          line_4 = 1;        
        }
        Is_ST = false;  
        return;
      }  
      i_ST = i_ST + 1;
    }
    if ( Is_ST == false ) {
      if ( highByte(inbyte) ) {
        if ( Skip_4 < FltSkip_4 ) {
          Skip_4 = Skip_4 + 1; }
        else {
          Skip_4 = 0;      
          ST[0] = lowByte(inbyte); 
          last_ST = GetLast_ST(ST[0]);
          if ( last_ST ) {
            i_ST = 1;
            Is_ST = true;            
          }
        }     
      } 
    } 
  } 
}


void TestSeaTalk_DB() {
  uint16_t inbyte;
  int jj, len;
  while (Serial_ST_available() > 0) {    // get the character
    inbyte = Serial_ST_read();
    if ( Is_ST ) {
      if ( highByte(inbyte) ) { 
        // Is_ST = false; return; 
        i_ST = 0;    // starts again
        last_ST = 1; // this makes the 2nd next if to fail:  if ( i_ST == last_ST ) 
      }
      ST[i_ST] = lowByte(inbyte); 
      if ( i_ST == 1 ) {
        last_ST = (ST[1] & 0x0F) + 2;
        jj = GetLast_STDB( ST[0] );
        if ( ( jj == 0) || ( jj != last_ST ) ){
          // so there is an error or is unknnow force ST to 2 bytes and abandon
          last_ST = 1;
        }
      }
      if ( i_ST == last_ST ) {
        // build the ST =
        const char STK[] = "ST=";
        len = 0;
        len += sprintf(nmea_4, STK);
        for( int n=0; n < last_ST; n++ ) {
          len += sprintf(nmea_4 + len, "%.2X ", ST[n] );
        }
        len += sprintf(nmea_4 + len, "%.2X", ST[last_ST] );  
        if (i_ST == 1 ) {
          //const char PPP[] = " ...<br>&emsp;&emsp;&emsp;Invalid or Unknown!";
          const char PPP[] = " ...\r\nInvalid or Unknown!";
          len += sprintf(nmea_4 + len, PPP);
          nmea_4[len] = 0x0D;
          nmea_4[len + 1] = 0x0A;
          nmea_4[len + 2] = 0x00;
          line_4 = 1; 
          Is_ST = false;   
          return; 
        }
        // here arrived all known datagrams without errors
        // write on a second line
        //const char AAA[] = "<br>&emsp;&emsp;&emsp;";
        const char AAA[] = "\r\n";
        len += sprintf(nmea_4 + len, AAA);
        len_ST = len;      
        jj = Parse_ST( ST[0] );    
        if (( jj < 255 ) && ( jj > 0 )) { 
          if ( Led4 == false ) { Led4 = true; }
          len = jj - 1;
        } 
        if ( jj == 0 ) {
          const char AUX[] = "Auxiliar value stored!";
          len += sprintf(nmea_4 + len, AUX);
        }
        if ( jj == 255 ) {
          const char NOT[] = "Datagram not converted!";
          len += sprintf(nmea_4 + len, NOT); 
        }
        nmea_4[len] = 0x0D;
        nmea_4[len + 1] = 0x0A;
        nmea_4[len + 2] = 0x00;
        line_4 = 1; 
        Is_ST = false;   
        return;
      }  
      i_ST = i_ST + 1;
    }
    if ( Is_ST == false ) {
      if ( highByte(inbyte) ) {
        if ( Skip_4 < FltSkip_4 ) {
          Skip_4 = Skip_4 + 1; }
        else {
          Skip_4 = 0;      
          ST[0] = lowByte(inbyte); 
          i_ST = 1;
          Is_ST = true;            
        }     
      } 
    } 
  } 
}

uint8_t GetLast_ST( byte b ) {
  switch (b) {
    case 0x00: return 4; break; 
    case 0x10: return 3; break; 
    case 0x11: return 3; break; 
    case 0x20: return 3; break; 
    case 0x21: return 4; break; 
    case 0x22: return 4; break; 
    case 0x23: return 3; break;
    case 0x25: return 6; break;
    case 0x26: return 6; break; 
    case 0x27: return 3; break; 
    case 0x50: return 4; break; 
    case 0x51: return 4; break; 
    case 0x52: return 3; break; 
    case 0x53: return 2; break; 
    case 0x54: return 3; break; 
    case 0x56: return 3; break;  
    case 0x58: return 7; break; 
    case 0x84: return 8; break; 
    case 0x89: return 4; break; 
    case 0x99: return 2; break; 
    case 0x9C: return 3; break;  
    return 0;     
  }
}

uint8_t GetLast_STDB( byte b ) {
  switch (b) {
    case 0x00: return 4; break; 
    case 0x10: return 3; break; 
    case 0x11: return 3; break; 
    case 0x20: return 3; break; 
    case 0x21: return 4; break; 
    case 0x22: return 4; break; 
    case 0x23: return 3; break;
    case 0x25: return 6; break;
    case 0x26: return 6; break; 
    case 0x27: return 3; break; 
    case 0x50: return 4; break; 
    case 0x51: return 4; break; 
    case 0x52: return 3; break; 
    case 0x53: return 2; break; 
    case 0x54: return 3; break; 
    case 0x56: return 3; break;  
    case 0x58: return 7; break; 
    case 0x84: return 8; break; 
    case 0x89: return 4; break; 
    case 0x99: return 2; break; 
    case 0x9C: return 3; break;   
// now the ones that are not translated
    case 0x01: return 7; break; 
    case 0x05: return 5; break; 
    case 0x24: return 4; break; 
    case 0x30: return 2; break;
    case 0x36: return 2; break;          
    case 0x38: return 3; break;
    case 0x55: return 3; break;  
    case 0x57: return 2; break;
    case 0x59: return 4; break;  
    case 0x61: return 5; break;
    case 0x65: return 2; break;          
    case 0x66: return 2; break;
    case 0x68: return 3; break;            
    case 0x6C: return 7; break;
    case 0x6E: return 9; break; 
    case 0x70: return 2; break;
    case 0x80: return 2; break;          
//    case 0x81: return 1; break;
    case 0x82: return 7; break; 
    case 0x83: return 9; break;      
    case 0x85: return 8; break;
    case 0x86: return 3; break; 
    case 0x87: return 2; break;
    case 0x88: return 5; break;          
    case 0x90: return 2; break;
    case 0x91: return 2; break;      
    case 0x92: return 4; break;
    case 0x93: return 2; break;          
    case 0x95: return 8; break;
    case 0x9A: return 11; break;
    case 0x9E: return 14; break;          
    case 0xA1: return 15; break;
    case 0xA2: return 6; break;  
//    case 0xA4: return ?; break;
//    case 0xA5: return ?; break;          
    case 0xA7: return 11; break;
    case 0xA8: return 5; break; 
    case 0xAB: return 5; break;  
    default: return 0; break;  
  }
}


// following are variables that are stored and later
// combined to construct NMEA sentences

char AppWindAng[8] = ",";         // ex:  "3276.5,"

char TotalMil[10] = ",N,";        // ex:   "6553.6,N,"
char TripMil[11]  = ",N";         // ex:   "10485.75,N"

boolean Is_MagVar = false;
char MagVar[6] = ",,";          // ex:   "90,E"

// minutes have 2 decimal points
char GPS_lat0[11] = ",,";      // ex:  "4104.33,N," meaning N41 4.33
char GPS_lon0[12] = ",,"; 
boolean Is_GPS0 = false;
boolean Is_GPS0Lat = false;
boolean Is_GPS0Lon = false;


// minutes have 3 decimal points
// will be used except if Is_GPS1 == false
char GPS_lat1[12] = ",,";
char GPS_lon1[13] = ",,";
boolean Is_GPS1 = false;

char GPS_time[10] = ",,";      // ex: "hhmmss,A,"
char GPS_date[8] = ",";        // ex: "ddmmyy," 
char GPS_sog[8] = ",";         // ex: "6553.5,"

// to know if Compass Heading is recently available
boolean Is_CompHead = false;
//uint32_t CompHead_Date = 0;
//const uint32_t CompHead_Recent = 20000; // value in miliseconds
uint16_t CompHead;

uint16_t Parse_ST( byte b ) {
  switch (b) {
    case 0x00: return Parse00(); break; 
    case 0x10: return Parse10(); break; 
    case 0x11: return Parse11(); break; 
    case 0x20: return Parse20(); break; 
    case 0x21: return Parse21(); break; 
    case 0x22: return Parse22(); break; 
    case 0x23: return Parse23(); break; 
    case 0x25: return Parse25(); break; 
    case 0x26: return Parse26(); break; 
    case 0x27: return Parse27(); break; 
    case 0x50: return Parse50(); break; 
    case 0x51: return Parse51(); break; 
    case 0x52: return Parse52(); break; 
    case 0x53: return Parse53(); break; 
    case 0x54: return Parse54(); break; 
    case 0x56: return Parse56(); break; 
    case 0x58: return Parse58(); break; 
    case 0x84: return Parse84(); break; 
    case 0x89: return Parse89(); break; 
    case 0x99: return Parse99(); break; 
    case 0x9C: return Parse84(); break; // same as 84
    default: return 255; break;
  }  
}

int checkSum( char msg[] ) {
  int XOR = 0;
  int len = strlen(msg) - 1;
  int k = 1 + len_ST;
  for (int i = k; i < len; i++) {
    XOR = XOR ^ msg[i];
  }
  return XOR;
}

// DBT with feet and meters
// ========================
uint16_t Parse00() {
  const char DBT[] = "$SDDBT,";
  uint16_t len = len_ST;
  len += sprintf(nmea_4 + len, DBT);
  if ( CheckNmeaFlt_4() == false ) { return 0; }  
  uint16_t ii = (ST[4] << 8) | ST[3] ;
  uint16_t DD = ii / 10;
  uint8_t F = ii - DD * 10;
//  len += sprintf(nmea_4 + len, "%u.%u,f,,,,*", DD, F ); 
  float x = ii * 0.03048;  // ii has depth in feet x 10  x will be meters!
//  len += sprintf(nmea_4 + len, "%u.%u,f,%.1f,M,,*", DD, F, x ); // need to change this on V41 and V64 of multiplexers
  len += sprintf(nmea_4 + len, "%u.%u,f,%.1f,M,,F*", DD, F, x ); 
  int XOR = checkSum( nmea_4 );
  len += sprintf(nmea_4 + len, "%.2X", XOR );
  return len + 1;
}


uint16_t Parse10() { 
  // only stores AppWindAng returns 0 no NMEA!
  uint16_t ii = (ST[2] << 8) | ST[3];
  char Z5 = '0'; if ( ii % 2 ) { Z5 = '5'; }
  ii = ii / 2;
  sprintf(AppWindAng, "%u.%c,", ii, Z5 );
  return 0;  
}


uint16_t Parse11() {
  const char MWV[] = "$WIMWV,";
  uint16_t len = len_ST;
  len += sprintf(nmea_4 + len, MWV);
  // now you can test the filtering
  if ( CheckNmeaFlt_4() == false ) { return 0; }     
  char AppWindSpeed[7];   // ex: "127.9," 
  uint8_t F = ST[3];
  uint8_t DD = (ST[2] & 0x7F);                         // knots
  len += sprintf(nmea_4 + len, "%sR,%u.%u,N,A*", AppWindAng, DD, F );  
  int XOR = checkSum( nmea_4 );
  len += sprintf(nmea_4 + len, "%.2X", XOR );
  return len + 1;
}

uint16_t Parse20() {
  const char VHW[] = "$VWVHW,";
  uint16_t len = len_ST;
  len += sprintf(nmea_4 + len, VHW);
  // now you can test the filtering
  if ( CheckNmeaFlt_4() == false ) { return 0; }
  uint16_t ii = (ST[3] << 8) | ST[2] ;
  uint16_t DD = ii / 10;
  uint8_t F = ii - DD * 10; 
  boolean flag = false; 
  len += sprintf(nmea_4 + len, ",,,,%u.%u,N,,*" , DD, F );  
  int XOR = checkSum( nmea_4 );
  len += sprintf(nmea_4 + len, "%.2X", XOR );
  return len + 1;  
}

uint16_t Parse21() {
  const char VLW[] = "$IIVLW,";
  uint16_t len = len_ST;
  len += sprintf(nmea_4 + len, VLW);
  // now you can test the filtering
  if ( CheckNmeaFlt_4() == false ) { return 0; }  
  uint32_t iiii = (ST[3] << 8) | ST[2] ;
  iiii = (ST[4] << 16) | iiii ;
  uint16_t DD = iiii / 100;
  uint16_t FF = iiii - DD * 100;
  sprintf(TripMil, "%u.%u,N" , DD, FF );
  len += sprintf(nmea_4 + len, "%s%u.%u,N*" , TotalMil, DD, FF );  
  int XOR = checkSum( nmea_4 );
  len += sprintf(nmea_4 + len, "%.2X", XOR );
  return len + 1;  
}

uint16_t Parse22() {
  const char VLW[] = "$IIVLW,";
  uint16_t len = len_ST;
  len += sprintf(nmea_4 + len, VLW);
  // now you can test the filtering
  if ( CheckNmeaFlt_4() == false ) { return 0; }
  uint16_t ii = (ST[3] << 8) | ST[2];
  uint16_t DD = ii / 10;
  uint8_t F = ii - DD * 10;
  sprintf(TotalMil, "%u.%u,N," , DD, F );
  len += sprintf(nmea_4 + len, "%u.%u,N,%s*" , DD, F, TripMil );  
  int XOR = checkSum( nmea_4 );
  len += sprintf(nmea_4 + len, "%.2X", XOR );
  return len + 1;  
}

uint16_t Parse23() {
  const char MTW[] = "$IIMTW,";
  uint16_t len = len_ST;
  len += sprintf(nmea_4 + len, MTW);
  // now you can test the filtering
  if ( CheckNmeaFlt_4() == false ) { return 0; }  
  int8_t WaterTemperature = ST[2]; 
  len += sprintf(nmea_4 + len, "%i,C*" , WaterTemperature );  
  int XOR = checkSum( nmea_4 );
  len += sprintf(nmea_4 + len, "%.2X", XOR );
  return len + 1;  
}

uint16_t Parse25() {
//  long time0 = micros();
  const char VLW[] = "$IIVLW,";
  uint16_t len = len_ST;
  len += sprintf(nmea_4 + len, VLW);
  // now you can test the filtering
  if ( CheckNmeaFlt_4() == false ) { return 0; } 
  uint8_t i = ST[1] >> 4; 
  uint32_t iiii = i * 65536 + ST[3] * 256 + ST[2];
  uint32_t D_Tot = iiii / 10;
  uint8_t F_Tot = iiii - D_Tot * 10;
  i = ST[6]; 
  iiii = i * 65536 + ST[5] * 256 + ST[4];
  uint32_t D_Tri = iiii / 100;
  uint8_t F_Tri = iiii - D_Tri * 100;  
  len += sprintf(nmea_4 + len, "%u.%.1u,N,%u.%.2u,N*" , D_Tot, F_Tot, D_Tri, F_Tri );  
  int XOR = checkSum( nmea_4 );
  len += sprintf(nmea_4 + len, "%.2X", XOR );
//  Serial.println( micros() - time0);  
  return len + 1; 
}

uint16_t Parse26() {
  const char VHW[] = "$VWVHW,";
  uint16_t len = len_ST;
  len += sprintf(nmea_4 + len, VHW);
  // now you can test the filtering
  if ( CheckNmeaFlt_4() == false ) { return 0; }
  uint16_t ii = (ST[3] << 8) | ST[2] ;
  uint16_t DD = ii / 100;
  uint16_t FF = ii - DD * 100;
  boolean flag = false; 
  len += sprintf(nmea_4 + len, ",,,,%u.%.2u,N,,*" , DD, FF );  
  int XOR = checkSum( nmea_4 );
  len += sprintf(nmea_4 + len, "%.2X", XOR );
  return len + 1;  
}

uint16_t Parse27() {
  const char MTW[] = "$IIMTW,";
  uint16_t len = len_ST;
  len += sprintf(nmea_4 + len, MTW);
  // now you can test the filtering
  if ( CheckNmeaFlt_4() == false ) { return 0; } 
  int16_t ii = (ST[3] << 8) | ST[2];
//  int16_t ii = iii;
  ii = ii - 100;
  int16_t DD;
  int8_t F;
  if ( ii > 0 ) {
    DD = ii / 10;
    F = ii - DD * 10; 
  }
  else {
    DD = ii / 10;
    F = DD * 10 - ii;
  }
  len += sprintf(nmea_4 + len, "%i.%.1i,C*" , DD, F );  
  int XOR = checkSum( nmea_4 );
  len += sprintf(nmea_4 + len, "%.2X", XOR );
  return len + 1;  
}

uint16_t Parse50() {
  uint16_t DD = ST[2];  // LatDegrees
  char LatNS = 'N'; if ( ST[4] & 0x80 ) { LatNS = 'S'; }  
  uint16_t ii = (ST[4] << 8) | ST[3];
  ii = ii & 0x7FFF;
  if ( ii > 6000 ) { ii = 6000; }
  uint16_t MM = ii / 100;
  uint16_t FF = ii - MM * 100;
  sprintf(GPS_lat0, "%u%.2u.%u,%c," , DD, MM, FF, LatNS ); 
  Is_GPS0Lat = true;
  if ( Is_GPS0Lon ) { Is_GPS0 = true;}
  return 0;
}

uint16_t Parse51() {
  uint16_t DD = ST[2];
  char LonWE = 'W'; if ( ST[4] & 0x80 ) { LonWE = 'E'; }
  uint16_t ii = (ST[4] << 8) | ST[3];
  ii = ii & 0x7FFF;
  if ( ii > 6000 ) { ii = 6000; }  
  uint16_t MM = ii / 100;
  uint16_t FF = ii - MM * 100;
  sprintf(GPS_lon0, "%.3u%.2u.%u,%c," , DD, MM, FF, LonWE ); 
  Is_GPS0Lon = true;
  if ( Is_GPS0Lat ) { Is_GPS0 = true;}
  return 0;
}

uint16_t Parse52() {
  uint16_t ii = (ST[3] << 8) | ST[2];
  uint8_t SS = ii / 10;
  uint8_t FF = ii - SS * 10; 
  sprintf(GPS_sog, "%u.%u," , SS, FF );
  return 0;  
}

uint16_t Parse53() {
  if ( ( Is_GPS0 == false ) && ( Is_GPS1 == false ) )  { return 0; } 
  const char RMC[] = "$GPRMC,";
  uint16_t len = len_ST;
  len += sprintf(nmea_4 + len, RMC);
  // now you can test the filtering
  if ( CheckNmeaFlt_4() == false ) { return 0; } 
  len += sprintf(nmea_4 + len, GPS_time );;
  if ( Is_GPS1 ) {
    len += sprintf(nmea_4 + len, "%s%s", GPS_lat1, GPS_lon1 );  
  }
  else {
    len += sprintf(nmea_4 + len, "%s%s", GPS_lat0, GPS_lon0 );      
  }
  len += sprintf(nmea_4 + len, GPS_sog ); 
  uint16_t ii = ( ST[1] & 0x30 ); ii = (ii >> 4) * 90 ;
  uint16_t jj = ( ST[2] & 0x7F ); jj = jj << 1;
  uint16_t kk = ( ST[1] & 0xC0 ); kk = kk >> 7;
  uint16_t COG = ii + jj + kk;
  len += sprintf(nmea_4 + len, "%u,%s,%s*", COG, GPS_date, MagVar ); 
  int XOR = checkSum( nmea_4 );
  len += sprintf(nmea_4 + len, "%.2X", XOR );
  return len + 1; 
}

uint16_t Parse54() {
  uint8_t HH = ST[3];
  uint8_t i = ( ST[2] & 0xFC );
  uint8_t MM = i >> 2;
  i = ( ST[2] & 0x03 ); i = i << 4;
  uint8_t j = ( ST[1] & 0xF0 ); j = j >> 4;
  uint8_t SS = i | j;
  sprintf(GPS_time, "%u%.2u%.2u,A," , HH, MM, SS ); 
  return 0;  
}

uint16_t Parse56() {
  uint8_t YY = ST[3];
  uint8_t DD = ST[2];
  uint8_t MM = ST[1] & 0xF0;  
  MM = MM >> 4; 
  sprintf(GPS_date, "%.2u%.2u%.2u" , DD, MM, YY );  
  return 0;  
}

uint16_t Parse58() {
  char LatNS, LonWE;
  ( ST[1] & 0x10 ) ? LatNS = 'S' : LatNS = 'N'; 
  ( ST[1] & 0x20 ) ? LonWE = 'E' : LonWE = 'W';
  uint16_t DD = ST[2];
  uint16_t ii = ST[3] << 8; ii = ii + ST[4];
  uint16_t MM = ii / 1000;
  uint16_t FF = ii - MM * 1000;
  sprintf(GPS_lat1, "%u%.2u.%.3u,%c," , DD, MM, FF, LatNS ); 
  // now longitude
  DD = ST[5]; 
  ii = ST[6] << 8; ii = ii + ST[7];
  MM = ii / 1000;
  FF = ii - MM * 1000;
  sprintf(GPS_lon1, "%.3u%.2u.%.3u,%c," , DD, MM, FF, LonWE );
  Is_GPS1 = true;  
  return 0;  
}

uint16_t Parse84() {
  uint8_t i, j;
  i = ( ST[1] & 0x30 ); i = (i >> 4);
  CompHead = i * 90 ;
  i = ( ST[2] & 0x3F ); i = i << 1;
  CompHead += i;
  i = ST[1] & 0xC0; i = i >> 6;
  j = 1;
  if (i == 0) { j = 0; }
  if (i == 3) { j = 2; }
  CompHead += j;
  Is_CompHead = true; // CompHead_Date = millis();
  uint16_t len = len_ST;
  if ( Is_MagVar ) {
    const char HDG[] = "$HCHDG,";
    len += sprintf(nmea_4 + len, HDG);
    // now you can test the filtering
    if ( CheckNmeaFlt_4() == false ) { return 0; }
    len += sprintf(nmea_4 + len, "%u,,,%s*", CompHead , MagVar );     
  }
  else {
    const char HDM[] = "$HCHDM,";
    len += sprintf(nmea_4 + len, HDM);
    // now you can test the filtering
    if ( CheckNmeaFlt_4() == false ) { return 0; }
    len += sprintf(nmea_4 + len, "%u,M*", CompHead );  
  }
  int XOR = checkSum( nmea_4 );
  len += sprintf(nmea_4 + len, "%.2X", XOR );
  return len + 1; 
}

uint16_t Parse89() {
  uint8_t i, j;
  i = ( ST[1] & 0x30 ); i = (i >> 4);
  CompHead = i * 90 ;
  i = ( ST[2] & 0x3F ); i = i << 1;
  CompHead += i;
  i = ST[1] & 0xC0; i = i >> 6;
  j = i / 2;
  CompHead += j;
  Is_CompHead = true; // CompHead_Date = millis();
  uint16_t len = len_ST;
  if ( Is_MagVar ) {
    const char HDG[] = "$HCHDG,";
    len += sprintf(nmea_4 + len, HDG);
    // now you can test the filtering
    if ( CheckNmeaFlt_4() == false ) { return 0; }
    len += sprintf(nmea_4 + len, "%u,,,%s*", CompHead , MagVar );     
  }
  else {
    const char HDM[] = "$HCHDM,";
    len += sprintf(nmea_4 + len, HDM);
    // now you can test the filtering
    if ( CheckNmeaFlt_4() == false ) { return 0; }
    len += sprintf(nmea_4 + len, "%u,M*", CompHead );  
  }
  int XOR = checkSum( nmea_4 );
  len += sprintf(nmea_4 + len, "%.2X", XOR );
  return len + 1; 
}

uint16_t Parse99() {
  int8_t i = ST[2];
  char EW = 'E' ; if ( i >= 0 ) { EW = 'W' ; } 
  i = abs(i);
  sprintf(MagVar, "%u,%c", i, EW );
  Is_MagVar = true;
  return 0;  
}
